/* Copyright (c) 2011, FoxTab. (team@foxtab.com)
 * All rights reserved.
 * See License.txt for further details.
 */

function FoxTab_Flash() {

    var t=this
    var args="";
    var commandsQueue = new Array()

	/*
	 *
	 */
	t.init = function(_id,_width,_height,_src,_bgColor,_transparent, _isFlash10, _isXUL) {
		t.id		  = _id
		t.width       = _width
		t.height      = _height
		t.src	      = _src
		t.bgColor     = _bgColor
		t.transparent = _transparent
		t.isFlash10   = _isFlash10
		t.isXUL       = _isXUL
	}
	/*
	 *
	 */
	t.getObject = function() {
	   if (t.bgColor==null) t.bgColor = "FFFFFF"

	   t.transparent="opaque"

	   var htmlObject = ""
	   t.width  +=""
	   t.height +=""
	   var divWidth  = t.width.replace("%25","%")    
	   var divHeight = t.height.replace("%25","%")

	   if (divWidth.indexOf("%")==-1) divWidth   +="px"
	   if (divHeight.indexOf("%")==-1) divHeight +="px"
	   var osString = ""
	   try{
	         osString = Components.classes["@mozilla.org/xre/app-info;1"].getService(Components.interfaces.nsIXULRuntime).OS;  
	   }catch(e){} 
	   if (t.isXUL!=false) {
		 xulHTML = "html:"
	   } else {
		 xulHTML = ""
	   }
	   

	   htmlObject += '<'+ xulHTML +'div id="foxTab_main_flash_div" style="width:'+divWidth+';height:'+divHeight+';background-color:#'+t.bgColor+'">'
	   
       if (osString.toLowerCase()=="linux") {
	  	 htmlObject += '<'+ xulHTML +'iframe src="" id="foxTab_iframe_title_text" frameborder="0" scrolling="no" style="background-color:#1A1A1A;position:absolute;display: none;top:0px;left:0px;z-index:100;"></'+ xulHTML +'iframe>'
	   	 htmlObject += '<'+ xulHTML +'iframe src="" id="foxTab_iframe_filter_text" frameborder="0" scrolling="no" style="background-color:#262626;position:absolute;display: none;top:0px;left:0px;z-index:101;"></'+ xulHTML +'iframe>'
	  	 htmlObject += '<'+ xulHTML +'iframe src="" id="foxTab_iframe_groups" frameborder="0" scrolling="no" style="background-color:#1A1A1A;position:absolute;display: none;z-index:102;"></'+ xulHTML +'iframe>'			
       }    
	   htmlObject += '<'+ xulHTML +'div id="foxTab_div_text" style="position:absolute;top:0px;left:0px;z-index:200;width:100%;text-align:center;"><'+ xulHTML +'div id="foxTab_siteTitle" xstyle="position:absolute"></'+ xulHTML +'div></'+ xulHTML +'div>'  
       htmlObject += '<'+ xulHTML +'div id="foxTab_div_filter_text" style="position:absolute;top:0px;left:0px;z-index:201;"><'+ xulHTML +'input type="text" onkeyup="foxTabWin.filterBoxKeyUp(this,event)" id="foxTab_filter_textbox" style="display:none;width:1px;font-family:arial;font-size:18px;vertical-align:middle;padding-right:5px;color:#ffffff;height:1px;background-color:transparent;border:0px solid #111111"/></'+ xulHTML +'div>'   
	   htmlObject += '<'+ xulHTML +'div id="foxTab_div_groups_panel" style="position:absolute;top:0px;left:0px;z-index:202;width:100%;"></'+ xulHTML +'div>'
	   htmlObject += '<'+ xulHTML +'div id="foxTab_div_info_panel" style="position:absolute;top:0px;left:0px;z-index:203;"></'+ xulHTML +'div>'
	   htmlObject += '<'+ xulHTML +'div id="foxTab_static_wall" style="position:absolute;top:0px;left:0px;z-index:204;"></'+ xulHTML +'div>'
	   htmlObject += '<'+ xulHTML +'div id="foxTab_static_wall_overlay" style="position:absolute;top:0px;left:0px;z-index:205;"></'+ xulHTML +'div>'
	   htmlObject += '<'+ xulHTML +'div id="block_tooltip" style="position:absolute;top:5px;left:5px;z-index:206;text-align:center;display:none"></'+ xulHTML +'div>'
	   htmlObject += '<'+ xulHTML +'div id="foxTab_static_wall_header" style="position:absolute;top:0px;left:0px;z-index:207;width:100%;text-align:center;display:none"><'+ xulHTML +'img src="chrome://foxtab/skin/images/topSitesHeader.png" id="wall_header"></'+ xulHTML +'img></'+ xulHTML +'div>'
	//   htmlObject += '<'+ xulHTML +'div id="foxTab_static_wall_search" style="position:absolute;top:10px;left:0px;z-index:208;width:100%;text-align:center;display:none"><'+ xulHTML +'div id="search-links"></'+ xulHTML +'div><'+ xulHTML +'div id="search-box"><'+ xulHTML +'div id="searchBG"><'+ xulHTML +'input type="text" id="searchBoxText" style="height:30px;width:290px;font-family:arial;border:0px solid #ffffff;margin-top:5px"/></'+ xulHTML +'div><'+ xulHTML +'div id="searchButton"></'+ xulHTML +'div></'+ xulHTML +'div><'+ xulHTML +'div id="search-engines" style="position:absolute;top:54px"></'+ xulHTML +'div></'+ xulHTML +'div>'
	   htmlObject += '<'+ xulHTML +'div id="foxTab_static_wall_search" style="position:absolute;top:10px;left:0px;z-index:208;width:100%;text-align:center;display:none"><'+ xulHTML +'div id="search-box"><'+ xulHTML +'div id="searchBG"><'+ xulHTML +'input type="text" id="searchBoxText" style="height:30px;width:290px;font-family:arial;border:0px solid #ffffff;margin-top:5px"/></'+ xulHTML +'div><'+ xulHTML +'div id="searchButton"></'+ xulHTML +'div><'+ xulHTML +'div id="googleLogo"></'+ xulHTML +'div></'+ xulHTML +'div></'+ xulHTML +'div>'

   
	   htmlObject += '<object classid="clsid:d27cdb6e-ae6d-11cf-96b8-444553540000" codebase="http://fpdownload.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=10,0,0,0"';
	   htmlObject += ' width="'+t.width+'" height="'+t.height+'" id="abdga" align="middle">';
	   htmlObject += '<'+ xulHTML +'embed src="'+t.src+'" quality="high" wmode="'+t.transparent+'" allowScriptAccess="always" allowFullScreen="true" FlashVars="'+args+'" bgcolor="#'+t.bgColor+'" menu="true" width="'+t.width+'" height="'+t.height+'" id="'+t.id+'" name="'+t.id+'"';
	   htmlObject += ' type="application/x-shockwave-flash" pluginspage="http://www.macromedia.com/go/getflashplayer"/>';
	   htmlObject += '</object>';

	   htmlObject += '</'+ xulHTML +'div>'
	   return htmlObject
	}
	/*
	 *
	 */
	t.write = function(div) {
	   div.innerHTML = t.getObject()
	   t.object = document.getElementById(t.id)
	   if (window.addEventListener) {
		  t.object.addEventListener('DOMMouseScroll', t.onMouseWheel, false);
	   } else {
		  t.object.attachEvent("onmousewheel",t.onMouseWheel);
	   }

	    t.object.addEventListener('mousedown', function(e) {
			foxTab_eventManager.executeEvent("foxTabFlash","mousedown",[e.button, e.clientX, e.clientY])
		}, false);
	}
	/*
	 *
	 */
	t.onMouseWheel = function(evt) {
	   var delta;
	   if (document.all) {
			delta = event.wheelDelta
			event.returnValue = false;
		  } else {
			delta = -1 * evt.detail
			if (evt.preventDefault) evt.preventDefault();
	   }
	   foxTab_eventManager.executeEvent("foxTabFlash","mousewheelevent",new Array("" + delta))
	}
	/*
	 *
	 */
	t.setArgs = function(_args) {
		args = _args
	}
	/*
	 *
	 */
	t.execute = function() {
	  var isFlash10 = true;
	  try {
		 var i;
		 if (arguments.length>1) {
				 if (t.isFlash10) {
					 var argsList = new Array();
					 for (i=2; i<arguments.length; i++) {
						 argsList.push(arguments[i]);
					 } 
					 t.object.execute(arguments[1], argsList);
				 } else {
					 t.object.SetVariable("JSArg0",arguments[1]);
					 if (arguments.length>2) {
						 for (i=1; i<arguments.length-1; i++) {
							 t.object.SetVariable("JSArg"+i,arguments[i+1]);
						 } 
					 }
					 t.object.SetVariable("JSArguments",arguments.length-2);
					 if (arguments[0]=="") arguments[0]="/"
					 t.object.TCallLabel(arguments[0],"executeCmd");
				 }
		 }
	   } catch (ex) {
		 addCommandToQueue(arguments[0],t.execute,arguments)
	   }
	}
	/*
	 *
	 */
	t.setVariable = function(arg,value) {
	  try {
		 t.object.SetVariable("/:"+arg,value);
	   } catch (ex) {
		   addCommandToQueue(t.setVariable,arguments)
	   }
	}
	/*
	 *
	 */
	var addCommandToQueue = function(level,fun,arg) {
	   if (commandsQueue[level]==null) commandsQueue[level] = new Array();
	   var arr = commandsQueue[level]
	   arr.push(fun)
	   arr.push(arg)
	}
	/*
	 *
	 */
	t.doCommandsQueue = function(level) {
	   var i;
	   if (commandsQueue[level]==null) commandsQueue[level] = new Array();
	   var arr = commandsQueue[level]
	   for (i=0; i<arr.length; i=i+2) {
		   fun = arr[i]
		   arg = arr[i+1]
		   fun.apply(this,arg)
	   }
	   commandsQueue[level]==null
	}
}


