/* Copyright (c) 2011, FoxTab. (team@foxtab.com)
 * All rights reserved.
 * See License.txt for further details.
 */
var foxTab_options = {

	ffPreferences : null,
	/******************************/
	init : function() {
			var t = foxTab_options;

			var ffPreferences = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);
			
			t.$e("foxTab_chb_siteTitle").checked   = ffPreferences.getBoolPref("foxTab.general.siteTitle");
			t.$e("foxTab_chb_displayFavoriteIcon").checked   = ffPreferences.getBoolPref("foxTab.general.displayFavoriteIcon");
			t.$e("foxTab_chb_contextMenu").checked = ffPreferences.getBoolPref("foxTab.general.contextMenu");
			t.$e("foxTab_chb_topSitesCM").checked = ffPreferences.getBoolPref("foxTab.general.addPageContextMenu");
			t.$e("foxTab_chb_topSitesToolbarBtn").checked = ffPreferences.getBoolPref("foxTab.general.displayTopSiteAddPageToolbarButton");
			t.$e("foxTab_chb_showToolbarButton").checked  = ffPreferences.getBoolPref("foxTab.general.displayMainFoxTabToolbarButton");
			t.$e("foxTab_chb_launchByAllTabsButton").checked = ffPreferences.getBoolPref("foxTab.general.enableAllTabsButton");
			t.$e("foxTab_chb_disaplyStatusBarIcon").checked = ffPreferences.getBoolPref("foxTab.general.disaplyStatusBarIcon");
			t.$e("foxTab_chb_tabEffect").checked   = ffPreferences.getBoolPref("foxTab.general.tabEffect");
			t.$e("foxTab_chb_multipleWindows").checked   = ffPreferences.getBoolPref("foxTab.general.multipleWindows");
			t.$e("foxTab_chb_hideDuplicateTabs").checked   = ffPreferences.getBoolPref("foxTab.general.hideDuplicateTabs");
			t.$e("foxTab_chb_mostRecentlyUsed").checked   = ffPreferences.getBoolPref("foxTab.general.mostRecentlyUsed");
			t.$e("foxTab_chb_navigationArrows").checked = ffPreferences.getBoolPref("foxTab.general.showNavigationArrows");

			if (ffPreferences.getBoolPref("foxTab.general.openInNewTab")==true) {
				t.$e("foxTab_newtab").value="topsites";
			} else {
			 	document.getElementById("foxtab_chb_googleSearch").disabled = true;
			}
			
			t.$e("foxtab_chb_googleSearch").checked = ffPreferences.getBoolPref("foxTab.enableGoogleSearch");

			if (ffPreferences.getCharPref("browser.startup.homepage").toLowerCase()=="chrome://foxtab/content/homepage.html") {
				foxTab_options.isTopSitesHomePage = true
				t.$e("foxTab_chb_topSitesHomePage").checked = true;
			}

			t.$e("foxTab_rdb_thumbnailsPreview").selectedItem = t.$e(ffPreferences.getCharPref("foxTab.general.thumbnailsPreviewBy"));
			t.$e("foxTab_chb_displayPanel").checked   = ffPreferences.getBoolPref("foxTab.visual.displayPanel");
			t.$e("foxTab_chb_displayThumbnailsReflection").checked   = ffPreferences.getBoolPref("foxTab.visual.displayThumbnailsReflection");
			t.$e("foxTab_chb_hideTheTabBar").checked   = ffPreferences.getBoolPref("foxTab.visual.hideTheTabBar");
			t.$e("foxTab_carouselSize_textBox").value    = ffPreferences.getCharPref("foxTab.layout.carouselSize");
			t.$e("foxTab_numOfThumbnail_textBox").value = ffPreferences.getCharPref("foxTab.layout.numOfThumbnail");
			t.$e("foxTab_numOfColumns_textBox").value    = ffPreferences.getCharPref("foxTab.layout.numOfColumns");
			t.$e("foxTab_numOfSlides_textBox").value    = ffPreferences.getCharPref("foxTab.layout.numOfSlides");
			t.$e("foxTab_wallMode_type").selectedItem = t.$e(ffPreferences.getCharPref("foxTab.layout.wallType"));
			var foxTab_quick_size = ffPreferences.getCharPref("foxTab.view.quickSize")
			if (foxTab_quick_size=="medium") foxTab_quick_size = "large"

			t.$e("foxTab_quick_size").value = foxTab_quick_size;
			t.$e("foxTab_interactive_size").value = ffPreferences.getCharPref("foxTab.view.interactiveSize");
			t.$e("foxTab_menulist_quickMode").value = ffPreferences.getCharPref("foxTab.quickMode");
			var osString = Components.classes["@mozilla.org/xre/app-info;1"].getService(Components.interfaces.nsIXULRuntime).OS;  
			if (osString.toLowerCase()=="darwin") {
				t.$e("foxTab_rdb_quick_fullScreen").style.display = "none"
				t.$e("foxTab_rdb_interactive_fullScreen").style.display = "none"
			}
			if ((t.$e("foxTab_quick_size").value=="fullScreen") || (t.$e("foxTab_interactive_size").value=="fullScreen")) {
			   foxTab_options.isCurrentFullScreen = true
			} else {
			   foxTab_options.isCurrentFullScreen = false
			}

			t.$e("foxTab_rdb_orientation").selectedItem = t.$e(ffPreferences.getCharPref("foxTab.general.orientation"));
		    foxTab_options.orientation = ffPreferences.getCharPref("foxTab.general.orientation")
			
			if (t.$e("foxTab_rdb_orientation").selectedItem.id=="orientationPortrait") {
				t.$e("orientationIcon").src = "chrome://foxtab/skin/images/options/portrait_icon.png"
			} else {
				t.$e("orientationIcon").src = "chrome://foxtab/skin/images/options/landscape_icon.png"
			}

			t.$e("foxTab_chb_keyboardQuickDefault").checked  = ffPreferences.getBoolPref("foxTab.keyboard.quick.enableDefault");
			t.$e("foxTab_chb_keyboardQuickCustom").checked   = ffPreferences.getBoolPref("foxTab.keyboard.quick.enableCustom");
			t.$e("foxTab_keyboard_quick_textBox").value      = ffPreferences.getCharPref("foxTab.keyboard.quick.customKey");
		
			t.$e("foxTab_chb_keyboardInteractiveDefault").checked  = ffPreferences.getBoolPref("foxTab.keyboard.interactive.enableDefault");
			t.$e("foxTab_chb_keyboardInteractiveCustom").checked   = ffPreferences.getBoolPref("foxTab.keyboard.interactive.enableCustom");
			t.$e("foxTab_keyboard_interactive_textBox").value      = ffPreferences.getCharPref("foxTab.keyboard.interactive.customKey");

			try{
				var osString = Components.classes["@mozilla.org/xre/app-info;1"].getService(Components.interfaces.nsIXULRuntime).OS;  
				if (osString.toLowerCase()=="darwin") {
					t.$e("foxTab_chb_keyboardInteractiveDefault").label = "F8"								
				}
			}catch(e){} 

			t.$e("foxTab_chb_suspension").checked         = ffPreferences.getBoolPref("foxTab.keyboard.EnableSuspension");
			t.$e("foxTab_suspensionTime_textBox").value   = ffPreferences.getCharPref("foxTab.keyboard.suspensionTime");
			t.$e("foxTab_chb_tabsThreshold").checked      = ffPreferences.getBoolPref("foxTab.general.enableTabsThreshold");
			t.$e("foxTab_tabsThreshold").value			 = ffPreferences.getCharPref("foxTab.general.quickModeThreshold");
			
			t.$e("foxTab_suspensionTime_textBox").disabled = !t.$e("foxTab_chb_suspension").checked;
			t.$e("foxTab_tabsThreshold").disabled		  = !t.$e("foxTab_chb_tabsThreshold").checked;

			if (t.$e("foxTab_chb_keyboardQuickCustom").checked) {
				t.$e("foxTab_keyboard_quick_textBox").disabled = false
			}

			if (t.$e("foxTab_chb_keyboardInteractiveCustom").checked) {
				t.$e("foxTab_keyboard_interactive_textBox").disabled = false
			}

			t.$e("foxTab_chb_mg_right_scroll").checked = ffPreferences.getBoolPref("foxTab.mouseGesture.rightClickScroll");
			t.$e("foxTab_chb_mg_ctrl_scroll").checked  = ffPreferences.getBoolPref("foxTab.mouseGesture.ctrlScroll");
			t.$e("foxTab_chb_mg_left_middle").checked  = ffPreferences.getBoolPref("foxTab.mouseGesture.leftMiddle");
			t.$e("foxTab_chb_mg_left_right").checked   = ffPreferences.getBoolPref("foxTab.mouseGesture.leftRight");

			t.$e("foxTab_menulist_filterPanel").value = ffPreferences.getCharPref("foxTab.find.status");
			t.$e("foxTab_menulist_groupPanel").value  = ffPreferences.getCharPref("foxTab.group.status");
			t.$e("foxTab_chb_closeGroupClearFilter").checked     = ffPreferences.getBoolPref("foxTab.group.clearFilter");
			
			if (ffPreferences.getBoolPref("foxTab.group.sortByName")) {
				t.$e("foxTab_menulist_sortGroup").value = 1;
			} else {
				t.$e("foxTab_menulist_sortGroup").value = 0;
			}

			t.$e("foxTab_chb_filterByTitle").checked   = ffPreferences.getBoolPref("foxTab.find.byTitle");
			t.$e("foxTab_chb_filterByDomain").checked  = ffPreferences.getBoolPref("foxTab.find.byDomain");
			t.$e("foxTab_chb_filterByURL").checked     = ffPreferences.getBoolPref("foxTab.find.byURL");

			t.$e("foxTab_chb_closeFilterClearFilter").checked     = ffPreferences.getBoolPref("foxTab.find.clearFilter");
			var extraBtn = document.documentElement.getButton('extra1');
			try{
				var osString = Components.classes["@mozilla.org/xre/app-info;1"].getService(Components.interfaces.nsIXULRuntime).OS;  
				if (osString.toLowerCase()=="darwin") {
					t.$e("okCloseButtons").style.display="block"; 
				}
				
				if (osString.toLowerCase()!="linux") {
					extraBtn.hidden = true;
				} else {
					extraBtn.addEventListener("mouseup"  , foxTab_options.save, false);				
				}
				if (osString.toLowerCase()!="winnt") {
					setTimeout( function() {window.sizeToContent();},1); 
				}
			}catch(e){
				extraBtn.hidden = true;	
				t.$e("okCloseButtons").style.display="block";
			} 
	},
	save : function () {
		   var t = foxTab_options;

		   if (t.$e("foxTab_chb_keyboardQuickCustom").checked) {
				customKey = t.$e("foxTab_keyboard_quick_textBox").value.toUpperCase();
				if ((customKey==null) || (customKey=="")) {
					alert("Please enter a key.");
					var pref_window = t.$e("foxTab_options_window")
					pref_window.showPane(t.$e("quickPane"))
					return false;
				}
		   }	
			
		   if (t.$e("foxTab_chb_keyboardInteractiveCustom").checked) {
				customKey = t.$e("foxTab_keyboard_interactive_textBox").value.toUpperCase();
				if ((customKey==null) || (customKey=="")) {
					alert("Please enter a key.");
					var pref_window = t.$e("foxTab_options_window")
					pref_window.showPane(t.$e("interactivePane"))
					return false;
				}
			}
			
			if ((!t.$e("foxTab_chb_filterByTitle").checked) && 
			   (!t.$e("foxTab_chb_filterByDomain").checked) && 
			   (!t.$e("foxTab_chb_filterByURL").checked)) {
					alert("You must select at least one filter criteria.");
					var pref_window = t.$e("foxTab_options_window")
					pref_window.showPane(t.$e("advancedPane"))
					return false;
			}

			var ffPreferences = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch);

			if (t.$e("foxTab_newtab").value=="topsites") {
				ffPreferences.setBoolPref("foxTab.general.openInNewTab", true);
			} else {
				ffPreferences.setBoolPref("foxTab.general.openInNewTab", false);
			}


			ffPreferences.setBoolPref("foxTab.enableGoogleSearch", t.$e("foxtab_chb_googleSearch").checked);

			ffPreferences.setBoolPref("foxTab.general.siteTitle", t.$e("foxTab_chb_siteTitle").checked);
			ffPreferences.setBoolPref("foxTab.general.displayFavoriteIcon", t.$e("foxTab_chb_displayFavoriteIcon").checked);
			ffPreferences.setBoolPref("foxTab.general.contextMenu", t.$e("foxTab_chb_contextMenu").checked);
			ffPreferences.setBoolPref("foxTab.general.addPageContextMenu", t.$e("foxTab_chb_topSitesCM").checked);
			ffPreferences.setBoolPref("foxTab.general.displayTopSiteAddPageToolbarButton", t.$e("foxTab_chb_topSitesToolbarBtn").checked);
			ffPreferences.setBoolPref("foxTab.general.displayMainFoxTabToolbarButton", t.$e("foxTab_chb_showToolbarButton").checked);
			ffPreferences.setBoolPref("foxTab.general.enableAllTabsButton", t.$e("foxTab_chb_launchByAllTabsButton").checked);
			ffPreferences.setBoolPref("foxTab.general.disaplyStatusBarIcon", t.$e("foxTab_chb_disaplyStatusBarIcon").checked);
			ffPreferences.setBoolPref("foxTab.general.showNavigationArrows", t.$e("foxTab_chb_navigationArrows").checked);
			ffPreferences.setBoolPref("foxTab.general.tabEffect", t.$e("foxTab_chb_tabEffect").checked);
			ffPreferences.setBoolPref("foxTab.general.multipleWindows", t.$e("foxTab_chb_multipleWindows").checked);
			ffPreferences.setBoolPref("foxTab.general.hideDuplicateTabs", t.$e("foxTab_chb_hideDuplicateTabs").checked);
			ffPreferences.setBoolPref("foxTab.general.mostRecentlyUsed", t.$e("foxTab_chb_mostRecentlyUsed").checked);
			ffPreferences.setCharPref("foxTab.general.thumbnailsPreviewBy", t.$e("foxTab_rdb_thumbnailsPreview").selectedItem.id);
			ffPreferences.setBoolPref("foxTab.visual.displayPanel", t.$e("foxTab_chb_displayPanel").checked);
			ffPreferences.setBoolPref("foxTab.visual.displayThumbnailsReflection", t.$e("foxTab_chb_displayThumbnailsReflection").checked);
			ffPreferences.setBoolPref("foxTab.visual.hideTheTabBar", t.$e("foxTab_chb_hideTheTabBar").checked);
			ffPreferences.setCharPref("foxTab.layout.carouselSize", t.$e("foxTab_carouselSize_textBox").value);
			ffPreferences.setCharPref("foxTab.layout.numOfColumns", t.$e("foxTab_numOfColumns_textBox").value);
			ffPreferences.setCharPref("foxTab.layout.numOfThumbnail", t.$e("foxTab_numOfThumbnail_textBox").value);
			ffPreferences.setCharPref("foxTab.layout.numOfSlides", t.$e("foxTab_numOfSlides_textBox").value);
			ffPreferences.setCharPref("foxTab.layout.wallType", t.$e("foxTab_wallMode_type").selectedItem.id);
			ffPreferences.setCharPref("foxTab.general.orientation", t.$e("foxTab_rdb_orientation").selectedItem.id);
			ffPreferences.setCharPref("foxTab.view.quickSize", t.$e("foxTab_quick_size").value);
			ffPreferences.setCharPref("foxTab.view.interactiveSize", t.$e("foxTab_interactive_size").value);
			

			var homePage = t.$e("foxTab_chb_topSitesHomePage").checked;

			if (homePage) {
				ffPreferences.setCharPref("browser.startup.homepage", "chrome://foxtab/content/homepage.html");
			} else {
				if (foxTab_options.isTopSitesHomePage) {
					ffPreferences.setCharPref("browser.startup.homepage", "");
				}
			}

			if ((t.$e("foxTab_quick_size").value=="fullScreen") || (t.$e("foxTab_interactive_size").value=="fullScreen")) {
			   foxTab_options.isNewFullScreen = true
			} else {
			   foxTab_options.isNewFullScreen = false
			}

			ffPreferences.setCharPref("foxTab.quickMode", t.$e("foxTab_menulist_quickMode").value);
			ffPreferences.setCharPref("foxTab.keyboard.quick.customKey", t.$e("foxTab_keyboard_quick_textBox").value);
			ffPreferences.setBoolPref("foxTab.keyboard.quick.enableDefault", t.$e("foxTab_chb_keyboardQuickDefault").checked);
			ffPreferences.setBoolPref("foxTab.keyboard.quick.enableCustom", t.$e("foxTab_chb_keyboardQuickCustom").checked);
			ffPreferences.setCharPref("foxTab.keyboard.interactive.customKey", t.$e("foxTab_keyboard_interactive_textBox").value);
			ffPreferences.setBoolPref("foxTab.keyboard.interactive.enableDefault", t.$e("foxTab_chb_keyboardInteractiveDefault").checked);
			ffPreferences.setBoolPref("foxTab.keyboard.interactive.enableCustom", t.$e("foxTab_chb_keyboardInteractiveCustom").checked);
			ffPreferences.setBoolPref("foxTab.keyboard.EnableSuspension", t.$e("foxTab_chb_suspension").checked);
			ffPreferences.setCharPref("foxTab.keyboard.suspensionTime", t.$e("foxTab_suspensionTime_textBox").value);
			ffPreferences.setBoolPref("foxTab.general.enableTabsThreshold", t.$e("foxTab_chb_tabsThreshold").checked);
			ffPreferences.setCharPref("foxTab.general.quickModeThreshold", t.$e("foxTab_tabsThreshold").value);

			ffPreferences.setBoolPref("foxTab.mouseGesture.rightClickScroll", t.$e("foxTab_chb_mg_right_scroll").checked);
			ffPreferences.setBoolPref("foxTab.mouseGesture.ctrlScroll", t.$e("foxTab_chb_mg_ctrl_scroll").checked);
			ffPreferences.setBoolPref("foxTab.mouseGesture.leftMiddle", t.$e("foxTab_chb_mg_left_middle").checked);
			ffPreferences.setBoolPref("foxTab.mouseGesture.leftRight", t.$e("foxTab_chb_mg_left_right").checked);


			ffPreferences.setCharPref("foxTab.find.status", t.$e("foxTab_menulist_filterPanel").value);
			ffPreferences.setCharPref("foxTab.group.status", t.$e("foxTab_menulist_groupPanel").value);
			ffPreferences.setBoolPref("foxTab.group.clearFilter", t.$e("foxTab_chb_closeGroupClearFilter").checked);


			if (t.$e("foxTab_menulist_sortGroup").value=="1") {
				ffPreferences.setBoolPref("foxTab.group.sortByName", true);
			} else {
				ffPreferences.setBoolPref("foxTab.group.sortByName", false);
			}

			ffPreferences.setBoolPref("foxTab.find.byTitle", t.$e("foxTab_chb_filterByTitle").checked);
			ffPreferences.setBoolPref("foxTab.find.byDomain", t.$e("foxTab_chb_filterByDomain").checked);
			ffPreferences.setBoolPref("foxTab.find.byURL", t.$e("foxTab_chb_filterByURL").checked);
			ffPreferences.setBoolPref("foxTab.find.clearFilter", t.$e("foxTab_chb_closeFilterClearFilter").checked);
			var kWinMediator = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
			var gBrowserWindow = kWinMediator.getMostRecentWindow( "navigator:browser" );
			if( gBrowserWindow != null ) {
				if (!t.$e("foxTab_chb_topSitesToolbarBtn").checked) {
					gBrowserWindow.foxTab.addFoxTabToolbarButton("foxTab_toolbarButton_topSitesAddPage", 0, true, true);
				}
				if (!t.$e("foxTab_chb_showToolbarButton").checked) {
					gBrowserWindow.foxTab.addFoxTabToolbarButton("foxTab_toolbarButton", 1, true, true);
				}

				try {
					var acceptBtn = t.$e("foxTab_options_window").getButton("accept") 
					acceptBtn.disabled = true;
				  } catch (e) {
				}

				var foxTabList = gBrowserWindow.foxTab.getAllFoxTabObjects();
				if (foxTab_options.orientation!=t.$e("foxTab_rdb_orientation").selectedItem.id) {
					if (foxTabList.length>0) {
						try{
							foxTabList[0].cacheDir.remove(true);
							foxTabList[0].cacheDir.create(Components.interfaces.nsIFile.DIRECTORY_TYPE, 0777);
						} catch(e) {
						} 
					}
				}
				var isMacSaved = false;
				for (var i=0;i<foxTabList.length;i++) {

					var info = Components.classes["@mozilla.org/xre/app-info;1"] .getService(Components.interfaces.nsIXULAppInfo);  

					if ((!foxTab_options.isCurrentFullScreen) && (foxTab_options.isNewFullScreen)) {
						if (foxTabList[i].isFlashOpen) {
							foxTabList[i].closeFoxTab();
						}
						if (info.version>="3.6") {
						} else {
							foxTabList[i].foxTabWindow.setAttribute('src', "");
							foxTabList[i].canvasType = foxTabList[i].CANVAS_WIN
						}
					} else if ((foxTab_options.isCurrentFullScreen) && (!foxTab_options.isNewFullScreen)) {
						if (foxTabList[i].isFlashOpen) {
							foxTabList[i].closeFoxTab();
						}
						if (info.version>="3.6") {
						} else {
							if (foxTabList[i].foxTabWindow!=null) foxTabList[i].foxTabWindow.close();
							foxTabList[i].canvasType = foxTabList[i].CANVAS_FLOAT
						}
					}

					foxTabList[i].setPref()
					var thumbsMaxDimension = foxTabList[i].getThumbnailDimensions(foxTabList[i].BIG_THUMBNAIL_SCALE);
					foxTabList[i].biggestWindowWidth  = thumbsMaxDimension.width;
					foxTabList[i].biggestWindowHeight = thumbsMaxDimension.height;

					if (((!foxTab_options.isCurrentFullScreen) && (foxTab_options.isNewFullScreen)) ||
						((foxTab_options.isCurrentFullScreen) && (!foxTab_options.isNewFullScreen))) {
						foxTabList[i].showWindow();
					}
					if (foxTabList[i].isFlashOpen) {
						if (foxTab_options.orientation!=t.$e("foxTab_rdb_orientation").selectedItem.id) {
							try{
								if (!isMacSaved) {
									var osString = Components.classes["@mozilla.org/xre/app-info;1"].getService(Components.interfaces.nsIXULRuntime).OS;  
									if (osString.toLowerCase()=="darwin") {
										for(var j=0; j<foxTabList[i].tabsList.length; j++) {
											foxTabList[i].saveTabByBrowser(foxTabList[i].tabsList[j].tabBrowser)	
										}
									}
									isMacSaved = true;
								}
							}catch(e){
									
							} 
						}
						foxTabList[i].closeFoxTab();
						foxTabList[i].openFoxTab(foxTabList[i].launchMode);
						try{
							var osString = Components.classes["@mozilla.org/xre/app-info;1"].getService(Components.interfaces.nsIXULRuntime).OS;  
							if (osString.toLowerCase()=="linux") {
								if ((foxTab_options.isCurrentFullScreen) && (!foxTab_options.isNewFullScreen)) {
									foxTabList[i].foxTabWindow.foxTabWin.resizeTimeOut("fullScreen");
								}
							}				
						}catch(e){}
					}
				}
				try{
					var osString = Components.classes["@mozilla.org/xre/app-info;1"].getService(Components.interfaces.nsIXULRuntime).OS;  
					if (osString.toLowerCase()=="darwin") {
						var pref_window = t.$e("foxTab_options_window")
						pref_window.showPane(t.$e("generalPane"))
					}
				}catch(e){} 
			}
			window.close();
	},
	/******************************/
	$e : function (elementId) {
		return document.getElementById(elementId);
	},
	/******************************/
	onListBoxChanged : function(listBox) {
		var deck = document.getElementById("foxTab_deck")
		deck.selectedIndex = listBox.selectedIndex
	},
	/******************************/
	onOrientationChanged : function(rdb) {
		if (rdb.selectedItem.id=="orientationPortrait") {
			document.getElementById("orientationIcon").src="chrome://foxtab/skin/images/options/portrait_icon.png"
		} else {
			document.getElementById("orientationIcon").src="chrome://foxtab/skin/images/options/landscape_icon.png"
		}
	},
	/******************************/
	onNewTabChanged : function(rdb) {
		if (rdb.selectedItem.value=="topsites") {
			document.getElementById("foxtab_chb_googleSearch").checked = true;
			document.getElementById("foxtab_chb_googleSearch").disabled = false;
		} else {
			document.getElementById("foxtab_chb_googleSearch").disabled = true;
		}
	},
	/******************************/
	onKeyboardDefaultChbChanged : function(chb, _type) {
	},
	/******************************/
	onKeyboardCustomChbChanged : function(chb, _type) {
		if (chb.checked) {
			document.getElementById("foxTab_keyboard_"+_type+"_textBox").disabled  = false
		} else {
			document.getElementById("foxTab_keyboard_"+_type+"_textBox").disabled  = true
		}
	},
	/******************************/
	onSuspensionTimeChbChanged : function(chb) {
		if (chb.checked) {
			document.getElementById("foxTab_suspensionTime_textBox").disabled  = false
		} else {
			document.getElementById("foxTab_suspensionTime_textBox").disabled  = true
		}
	},
	/******************************/
	onTabsThresholdChbChanged : function(chb) {
		if (chb.checked) {
			document.getElementById("foxTab_tabsThreshold").disabled  = false
		} else {
			document.getElementById("foxTab_tabsThreshold").disabled  = true
		}
	},
	/******************************/
	toggleToolbarButton : function(object, btnID, pref, location) {
	    var wm = Components.classes['@mozilla.org/appshell/window-mediator;1'].getService(Components.interfaces.nsIWindowMediator);
	    var e = wm.getEnumerator(null);
	  
	    var winList = new Array();
	    while (e.hasMoreElements()) {
		  var w = e.getNext();
		  if (w.foxTab) {
				var btn = w.document.getElementById(btnID);
				if (object.checked) {
					if (btn) {
						btn.style.display = '';
					} else {
						 w.foxTab.addFoxTabToolbarButton(btnID, location, true);
					}
					ffPreferences.setBoolPref(pref, true);
				} else {
					if (btn) {
						btn.style.display = 'none';
					}
					 
					ffPreferences.setBoolPref(pref, false);
				}displayMainFoxTabToolbarButton

		  }
	    }	
	    return winList;
	},

	/******************************/
	checkKeyboardRDB : function(rdb, _type) {

		if (rdb.selectedItem.id=="keyboard"+_type+"Custom") {
			document.getElementById("foxTab_keyboard_"+_type+"_textBox").disabled  = false
			document.getElementById("foxTab_keyboard_"+_type+"_ctrl").disabled  = false
			if (_type=="quick") {
				document.getElementById("foxTab_tabsThresholdLabelPrefix").disabled = true
				document.getElementById("foxTab_tabsThresholdLabelSuffix").disabled = true
				document.getElementById("foxTab_tabsThreshold").disabled = true
			}
		} else {
			document.getElementById("foxTab_keyboard_"+_type+"_textBox").disabled  = true
			document.getElementById("foxTab_keyboard_"+_type+"_ctrl").disabled  = true
			if (_type=="quick") {
				document.getElementById("foxTab_tabsThresholdLabelPrefix").disabled = false
				document.getElementById("foxTab_tabsThresholdLabelSuffix").disabled = false
				document.getElementById("foxTab_tabsThreshold").disabled = false
			}
		}
	},
	/******************************/
	openHelpPage : function() {
		var kWinMediator = Components.classes["@mozilla.org/appshell/window-mediator;1"].getService(Components.interfaces.nsIWindowMediator);
		var gBrowserWindow = kWinMediator.getMostRecentWindow( "navigator:browser" );
		if( gBrowserWindow != null ) {
			gBrowserWindow.foxTab.gBrowser.selectedTab = gBrowserWindow.foxTab.gBrowser.addTab("http://www.foxtab.com/gettingstarted/?q=a");	
			window.close();
		}
	}
}
